#include <itf/option.h>
#include <itf/itf.h>
#include <sim/sim.h>
#include <lib/example.h>
#include "utils-bp.h"

#define DB(x)


/******************************************************************************
 * Error functions
 */

real cross_entropy(y,d)
real y,d;
{
  y = bound(y,MIN_Y,1.0-MIN_Y);
  if      (zerop(d)) return 1.0/(1.0-y);
  else if (onep(d))  return -1.0/y;
  else		     return ((1.0-d)/(1.0-y) - d/y);
}


real tolerance_cross_entropy(y,d)
real y,d;
{
  /*
   * Should really have np.always-bp-unit = 1 with this
   */
  real tol = np->tolerance - np->midrange_tolerance;
  real error = 0.0;
  y = bound(y,MIN_Y,1.0-MIN_Y);
  if        (zerop(d)) {
    if (y > tol) error = ((1.0-tol)/(1.0-y) - tol/y);
  } else if (onep(d)) {
    if (y < (1.0-tol)) error = (tol/(1.0-y) - (1.0-tol)/y);
  } else 
    error = cross_entropy(y,d);
  DB(printf("tce: y:%f d:%f t:%f e:%f\n",y,d,tol,error););
  return error;
}
