#include <itf/option.h>
#include <itf/itf.h>
#include <sim/sim.h>
#include <lib/ex-load.h>

/***
 * Set the `dEdy' fields of all units in hidden layers and below to zero
 */
void SetBiases(net)
NETWORK *net;
{
  int i,t;
  DoLayer(net->p->bias_layer_n) {
    ForEachUnit(UNIT) {
      UNIT_OUTPUT(unit) = 1.0;
#ifdef TIME_NETWORK
      for (t=0;t<MAX_T;t++)
	UNIT_OUTPUT_T(unit,t) = 1.0;
#endif
    } EndForEach;
  } EndDo;
}

real WorkingTolerance(net,target)
NETWORK* net;
real target;
{
  /***
   * Integrate this with using different squashing functions
   * that give output in (-1,1) or (0,1)
   */
  if (target==1 || target==-1 || net->p->unit_function==0 && target==0)
    return net->p->tolerance;
  else
    return net->p->midrange_tolerance;
}

int PerformNet(net)
NETWORK *net;
{
#ifdef DBM_NETWORK
  return PerformNet_DBM(net);
#else
  ForwardProp(net);
  return ComputeError(net);
#endif DBM_NETWORK
}


