extern int use_plus_minus_options;

typedef (*verifyfunc) ARGS((char*, char*, int));

enum ARG_JOIN {ARG_NOJOIN,ARG_OR,ARG_AND,ARG_SEQ,ARG_XOR};
enum ARG_TYPE {
  ARG_BAD_TYPE,
  ARG_LITERAL,
  ARG_INTEGER,
  ARG_FLOAT,
  ARG_REAL,
  ARG_DOUBLE,
  ARG_STRING,
  ARG_CHAR,
  ARG_BOOLEAN,
  ARG_NATURAL,
  ARG_SHORT,
  ARG_LONG,
  ARG_FORMAT,
  ARG_AREA_FORMAT,
  ARG_RANGE_STRING,
  ARG_VAR_NAME,
  ARG_MEMBER_NAME,
  ARG_FILE_IN,
  ARG_FILE_OUT,
};

#define FOUND_ACTUAL		0x1
#define NO_ACTUAL		0x2
#define OPTION_ON		0x4
#define OPTION_OFF		0x8
#define OPTION_PRESENT		0x10
#define SATISFIED_ARGS		0x20
#define PARTIALLY_FILLED	0x40
#define FILLED_AND_CLOSED	0x80
#define ACTUAL_CLEARED		0x1000
#define ACTUAL_FLAGS (FOUND_ACTUAL|NO_ACTUAL|OPTION_ON|OPTION_OFF|OPTION_PRESENT|SATISFIED_ARGS|PARTIALLY_FILLED|FILLED_AND_CLOSED)
#define ALL_ACTUAL_FLAGS	0xFFFF

#define ARG_DESC_MAGIC_START	0x5c6b7a89
#define ARG_DESC_MAGIC_END	0xc5d4e3f2

struct ARG_DESC {
  int			magic_number;	/* ARG_MAGIC_START or ARG_MAGIC_END */
  struct ARG_LIST	**arg_list;
  int			n_lists;
  char			*name;
  int			filling_aps;	/* 1 if we are just filling aps, not
					   building the whole thing */
  int			fill_list;	/* next list to fill */
  int			complete;
  char			**option_names;	/* to check for ambiguities */
  int			(*func_ptr)();
};

struct ARG_LIST {
  struct ARG_GROUP	*group;
  enum ARG_JOIN		join;
  struct ARG_LIST	*next;
  struct ARG_LIST	*parent;
  int			id;		/* just to uniquely identify */
  generic		***ap_loc;
  int			*ap_should_point_to_null;
  int			n_aps;
  int			actual;
};

struct ARG_GROUP {
  enum {ARG_GROUP_SIMPLE, ARG_GROUP_OPTION}
  				tag;
  union {
    struct {
      struct ARG_OPTION		*option;
      struct ARG_LIST		*arg_list;
      int			optional;
    }			option;
    struct {
      struct ARG_SIMPLE		*arg_simple;
    }			simple;
  }				u;
  int				*presence;
  int				*neg_presence;
  char				*help;
  int				actual;
};

struct ARG_SIMPLE {
  char			*prompt;
  int			vector;		/* argument is a vector */
  enum ARG_TYPE		type;
  verifyfunc		verify;
  generic		*store;		/* where to store data */
  int			*store_len;	/* where to store vector length */
  int			vector_len;	/* where to store vector length */
  int			actual;		/* store info about actual arg */
  int			id;
};

struct ARG_OPTION {
  char			*name;
  int			no_prefix;
  int			is_signed;
  int			*sign;		/* store sign here */
  int			*neg_sign;	/* store !sign here */
  int			*presence;	/* store 1 here if present */
  int			*neg_presence;	/* store 0 here if present */
  char			*help;
  int			actual;		/* store info about actual arg */
};
