#include "useful.h"

FILE *dout = stdout;
char *myname;
char *true_string = "true";
char *false_string = "false";
char *undefined_string = "undefined";
char *bad_boolean_string = "bad_boolean";
int stand_alone = 1;

char *SysError(n)
int n;
{
  static char str[30];
  extern char *sys_errlist[];
  extern int sys_nerr;
  if (n>0 || n<sys_nerr) return sys_errlist[n];
  else {
    sprintf(str, "No error message for %d", n);
    return str;
  }
}

int IsAsciiString(p)
char *p;
{
  if (*p==NULL)
    return 0;
  for (; *p; p++)
    if (!isascii(*p))
      return 0;
  return 1;
}

char *BooleanString(b)
int b;
{
  switch (b) {
  case 0: return false_string;
  case -1: return undefined_string;
  case 1: return true_string;
  default: return bad_boolean_string;
  }
}

void
  Abort ()
{
  exit(1);
}
/*  Error should be called like:
 *    Error(format, arg1, arg2...);
 *  Note: format cannot be declared
 *  separately because of the definition of varargs.
 */

void ErrorV(args)
va_list *args;
{
  char *fmt;

  (void) fprintf(stderr, "%s: ", myname);
  fmt = va_arg(*args, char *);
  (void) vfprintf(stderr, fmt, *args);
  va_end(*args);
  (void) fputc('\n', stderr);
}

/*VARARGS0*/
void
  Error (va_alist)
va_dcl
{
  va_list args;
  char *fmt;

  (void) fprintf(stderr, "%s: ", myname);
  va_start(args);
  fmt = va_arg(args, char *);
  (void) vfprintf(stderr, fmt, args);
  va_end(args);
  (void) fputc('\n', stderr);
}

/*VARARGS0*/
void
  ErrorAbort (va_alist)
va_dcl
{
  va_list args;
  char *fmt;
  
  (void) fprintf(stderr, "%s: ", myname);
  va_start(args);
  fmt = va_arg(args, char *);
  (void) vfprintf(stderr, fmt, args);
  va_end(args);
  (void) fputc('\n', stderr);
  exit(1);
  (void) abort();
}

char *callocOrAbort(nelem, elsize)
unsigned nelem, elsize;
{
  char *p;
  p = calloc(nelem, elsize);
  if (p==NULL)
    ErrorAbort("out of memory");
  return p;
}

char *reallocOrAbort(old, size)
char *old;
unsigned size;
{
  char *p;
  p = realloc(old, size);
  if (p==NULL)
    ErrorAbort("out of memory");
  return p;
}

char *pchar(c)
char c;
{
  static char buf[10];
  if (isprint(c)) {
    buf[0] = buf[2] = '\'';
    buf[1] = c;
  } else if (c=='\0')
    strcpy(buf,"(nullchar)");
  else
    sprintf(buf,"(char:%d)",c);
  return buf;
}

void strncpy_null(dest,src,n)
char *dest;
char *src;
int n;
{
  strncpy(dest,src,n-1);
  dest[n-1] = '\0';
}

/***
 * copies str to buf and returns a pointer to the end of the string
 */
char *strcpyend(buf,str)
char *buf;
char *str;
{
  while (*str) *(buf++) = *(str++);
  *buf = 0;
  return buf;
}

/***
 * concats str to buf and returns a pointer to the end of the string
 */
char *strcatend(buf,str)
char *buf;
char *str;
{
  while (*buf) buf++;
  while (*str) *(buf++) = *(str++);
  *buf = 0;
  return buf;
}

int IsLegalVarName(name)
char *name;
{
  if (!name || !*name) return 0;
  if (!(   *name >= 'a' && *name <= 'z'
	|| *name >= 'A' && *name <= 'Z'
	|| *name=='$' || *name=='@')) return 0;
  while (*name)
    if (   *name >= 'a' && *name <= 'z'
	|| *name >= 'A' && *name <= 'Z'
	|| *name >= '0' && *name <= '9'
	|| *name=='_' || *name=='-' || *name=='$' || *name=='@') name++;
    else
      return 0;
  return 1;
}

