/*
 * $Id: field-access.h,v 1.1 90/12/07 11:50:30 drew Exp $
 * 
 * $Log:	field-access.h,v $
# Revision 1.1  90/12/07  11:50:30  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

typedef struct FIELD_ACCESS {
  struct BINDING	access_binding;
  struct ADDRESS_ENV	access_env;
  struct BINDING	*field_binding;
  struct BINDING	*struct_binding;
  int			field_offset;
  int			field_id;
  char			*field_name;	/* the name of the field we are
					   accessing, e.g. "dEdt" */
  char			*access_name;	/* the name of the whole thing we are
					   accessing, e.g. ".dEdt[3]" */
  char			*struct_name;
  int			access_vector;	/* true if we should access an
					   element of the field vector */
  int			vector_elt;	/* the # of the elt */
  char			**extra;	/* extra tokens specifying the field */
};
