/*
 * $Id: option.h,v 1.1 90/12/07 11:50:55 drew Exp $
 * 
 * $Log:	option.h,v $
# Revision 1.1  90/12/07  11:50:55  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#ifndef _OPTION_
#define _OPTION_

extern char *plus_minus_options;

/***
 * There are two different types of option
 *
 *           	Style 1		Style 2
 * presence	-read		-read
 * signed	-read +read	-read -noread		
 * usage linead	+/-read		-[no]read
 */

#define OPTSIGN 0x1
#define OPTPRES 0x2
#define OPTREALARG 0x4
#define OPTINTARG 0x8
#define OPTSTRARG 0x10
#define SOMEOPT (OPTSIGN|OPTPRES|OPTREALARG|OPTINTARG|OPTSTRARG)
#define OPTLAST 0x20

typedef struct OPTION {
  int	type;
  char	*name;
  int	min_prefix_len;
};

extern int IsOption();		/* (token) */
extern int OptionSign();	/* (token,option,options) */
extern int OptionMatch();	/* (token,option,options,sign) */
#endif _OPTION_
