/*
 * $Id: range.h,v 1.1 90/12/07 11:50:58 drew Exp $
 * 
 * $Log:	range.h,v $
# Revision 1.1  90/12/07  11:50:58  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#ifndef _RANGE_
#define _RANGE_

typedef struct AREA_FORMAT { /* BIND */
  int rows;
  int cols;
  char code;
  short join;		/* boolean: true=join up with previous? */
  short lowzero;	/* boolean: true=rows ordered from bottom to top */
} AREA_FORMAT;

struct RANGE {
  int lo;
  int hi;
  int depth;
  int nothing;	/* if =1, nothing is in this range */
};

int InRange ARGS((int, struct RANGE*, struct AREA_FORMAT*));
int InRangeString ARGS((int, char*));
int CompareWithRangeString ARGS((int, char*, int*));
void RangeDimensions();	/* (max, range, format, &rows, &cols) */
void RangeForControl();	/* (max, range, format, &first_row, &top_row, &row_inc, &row_len) */
int RangePosition();	/* (n, range, format, &row, &col) */
int ParseRange();	/* (tok, range, format) */
int ParseRangeColon();	/* (tok, colon_n, range, format) */
int ParseAreaFormat();	/* (format_str, format) */
void SetDefaultRange();	/* (range, format) */
int RangeSize();		/* (max, range, format) */
char *PrintRangeString ARGS((struct RANGE *));
int AreaToRange ARGS((int, struct RANGE*, struct AREA_FORMAT*));
int RangeToArea ARGS((int, struct RANGE*, struct AREA_FORMAT*));

#endif _RANGE_
