/*
 * $Id: utils.c,v 1.1 90/12/07 11:51:13 drew Exp $
 * 
 * $Log:	utils.c,v $
# Revision 1.1  90/12/07  11:51:13  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include "itf.h"

char *true_string = "true";
char *false_string = "false";
char *undefined_string = "undefined";
char *bad_boolean_string = "bad_boolean";

int IsAsciiString(p)
char *p;
{
  if (*p==NULL)
    return 0;
  for (; *p; p++)
    if (!isascii(*p))
      return 0;
  return 1;
}

char *BooleanString(b)
int b;
{
  switch (b) {
  case 0: return false_string;
  case -1: return undefined_string;
  case 1: return true_string;
  default: return bad_boolean_string;
  }
}

char *pchar(c)
char c;
{
  static char buf[10];
  if (isprint(c)) {
    buf[0] = buf[2] = '\'';
    buf[1] = c;
  } else if (c=='\0')
    strcpy(buf,"(nullchar)");
  else
    sprintf(buf,"(char:%d)",c);
  return buf;
}

void strncpy_null(dest,src,n)
char *dest;
char *src;
int n;
{
  strncpy(dest,src,n-1);
  dest[n-1] = '\0';
}

/***
 * copies str to buf and returns a pointer to the end of the string
 */
char *strcpyend(buf,str)
char *buf;
char *str;
{
  while (*str) *(buf++) = *(str++);
  *buf = 0;
  return buf;
}

/***
 * concats str to buf and returns a pointer to the end of the string
 */
char *strcatend(buf,str)
char *buf;
char *str;
{
  while (*buf) buf++;
  while (*str) *(buf++) = *(str++);
  *buf = 0;
  return buf;
}

int IIsLegalVarName(name)
char *name;
{
  if (!name || !*name) return 0;
  if (!(   *name >= 'a' && *name <= 'z'
	|| *name >= 'A' && *name <= 'Z'
	|| *name=='$' || *name=='@')) return 0;
  while (*name)
    if (   *name >= 'a' && *name <= 'z'
	|| *name >= 'A' && *name <= 'Z'
	|| *name >= '0' && *name <= '9'
	|| *name=='_' || *name=='-' || *name=='$' || *name=='@') name++;
    else
      return 0;
  return 1;
}

int IsLegalVarName(name)
char *name;
{
  return IIsLegalVarName(name);
}

int IIsInteger(str)
char *str;
{
  char *end;
  extern long strtol();
  if (!str || !*str) return 0;
  (void) strtol(str,&end,0);
  if (end==str || *end!='\0') return 0;
  else return 1;
  /*
  if (!str || *str<'0' && *str>'9') return 0;
  for(;*str;str++) if (*str<'0' || *str>'9') return 0;
  return 1;
  */
}

/***
 * IIsNumber(str)
 * Recognizes strings of the form [-/+]n*[.n*][e/E[-/+]n*]}
 */
int IIsNumber(str)
char *str;
{
  char *end;
  if (!str || !*str) return 0;
  (void) strtod(str, &end);
  if (end==str || *end!='\0')
    return 0;
  else return 1;
#ifdef OBSELETE
  if (!str || !*str) return 0;
  /* can't start with 'e' or 'E' */
  if (*str=='e' || *str=='E') return 0;
  if (*str && (*str=='-' || *str=='+')) str++;
  while (*str && *str>='0' && *str<='9') str++;
  if (*str && *str=='.') {
    str++;
    while (*str && *str>='0' && *str<='9') str++;
  }
  if (*str && (*str=='e' || *str=='E')) {
    str++;
    if (*str && (*str=='-' || *str=='+')) str++;
    while (*str && *str>='0' && *str<='9') str++;
  }
  /***
   * should have reached the end of the string
   */
  if (!*str) return 1;
  else return 0;
#endif OBSELETE
}

