/*
 * $Id: build.h,v 1.1 90/12/07 12:00:36 drew Exp $
 * 
 * $Log:	build.h,v $
 * Revision 1.1  90/12/07  12:00:36  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

int BuildNet();
int BuildLayer_();
int Connect_();
extern char build_buf[BUFSIZ];
extern int n_links_built;
extern int abort_on_error;

#define ABORTBUILD(net) \
  if (abort_on_error) {\
    if ((net)!=NULL) {\
      NETWORK *_tmp_net_=(net);\
      _tmp_net_->build_error=1;\
    }\
    IAbort();\
  } else return -1;

#define DFLT (-1)

#define BuildLayer(net,layer_n,n_units,UNIT_TYPE,params) \
  BuildLayer_(net,layer_n,n_units,TAG(UNIT_TYPE),params)

#define ConnectComplete(s_net,s_layer,d_net,d_layer,LINK_TYPE) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_COMPLETE|UNI_DIRECTIONAL,0,0,0)
#define ConnectCompleteGn(s_net,s_layer,d_net,d_layer,LINK_TYPE,group_n) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_COMPLETE|UNI_DIRECTIONAL,0,0,group_n)

#define ConnectPartial(s_net,s_layer,d_net,d_layer,n_links,LINK_TYPE) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_PARTIAL|UNI_DIRECTIONAL,0,n_links,0)
#define ConnectPartialGn(s_net,s_layer,d_net,d_layer,n_links,LINK_TYPE,group_n) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_PARTIAL|UNI_DIRECTIONAL,0,n_links,group_n)

#define ConnectBlock(s_net,s_layer,d_net,d_layer,block_size,LINK_TYPE) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_BLOCK|UNI_DIRECTIONAL,0,block_size,0)
#define ConnectBlockGn(s_net,s_layer,d_net,d_layer,block_size,LINK_TYPE,group_n) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_BLOCK|UNI_DIRECTIONAL,0,block_size,group_n)

#define ConnectUnitComplete(s_net,s_layer,d_net,d_layer,d_unit,LINK_TYPE) \
  ConnectUnit_(s_net,s_layer,d_net,d_layer,d_unit,TAG(LINK_TYPE),CONNECT_COMPLETE|UNI_DIRECTIONAL,0,0,0)
#define ConnectUnitCompleteGn(s_net,s_layer,d_net,d_layer,d_unit,LINK_TYPE,group_n) \
  ConnectUnit_(s_net,s_layer,d_net,d_layer,d_unit,TAG(LINK_TYPE),CONNECT_COMPLETE|UNI_DIRECTIONAL,0,0,group_n)

#define ConnectUnitPartial(s_net,s_layer,d_net,d_layer,d_unit,n_links,LINK_TYPE) \
  ConnectUnit_(s_net,s_layer,d_net,d_layer,d_unit,TAG(LINK_TYPE),CONNECT_PARTIAL|UNI_DIRECTIONAL,0,n_links,0)
#define ConnectUnitPartialGn(s_net,s_layer,d_net,d_layer,d_unit,n_links,LINK_TYPE,group_n) \
  ConnectUnit_(s_net,s_layer,d_net,d_layer,d_unit,TAG(LINK_TYPE),CONNECT_PARTIAL|UNI_DIRECTIONAL,0,n_links,group_n)

#define ConnectUnitBlock(s_net,s_layer,d_net,d_layer,d_unit,block_start,block_size,LINK_TYPE) \
  ConnectUnit_(s_net,s_layer,d_net,d_layer,d_unit,TAG(LINK_TYPE),CONNECT_BLOCK|UNI_DIRECTIONAL,block_start,block_size,0)
#define ConnectUnitBlockGn(s_net,s_layer,d_net,d_layer,d_unit,block_start,block_size,LINK_TYPE,group_n) \
  ConnectUnit_(s_net,s_layer,d_net,d_layer,d_unit,TAG(LINK_TYPE),CONNECT_BLOCK|UNI_DIRECTIONAL,block_start,block_size,group_n)

#define ConnectCompleteBidir(s_net,s_layer,d_net,d_layer,LINK_TYPE) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_COMPLETE|BI_DIRECTIONAL,0,0,0)
#define ConnectCompleteBidirGn(s_net,s_layer,d_net,d_layer,LINK_TYPE,group_n) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_COMPLETE|BI_DIRECTIONAL,0,0,group_n)

#define ConnectBlockBidir(s_net,s_layer,d_net,d_layer,block_start,block_size,LINK_TYPE) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_BLOCK|BI_DIRECTIONAL,block_start,block_size,0)
#define ConnectBlockBidirGn(s_net,s_layer,d_net,d_layer,block_start,block_size,LINK_TYPE,group_n) \
  Connect_(s_net,s_layer,d_net,d_layer,TAG(LINK_TYPE),CONNECT_BLOCK|BI_DIRECTIONAL,block_start,block_size,group_n)

#define ConnectCompleteBidirNet(net_n,LINK_TYPE) \
  ConnectBidirNet_(net_n,TAG(LINK_TYPE),CONNECT_COMPLETE,0)

#define ConnectCompleteNet(net_n,LINK_TYPE,mode,str) \
  ConnectCompleteNet_(net_n,TAG(LINK_TYPE),mode|CONNECT_COMPLETE,str)

#define Connect(s_net,s_layer,s_unit,d_net,d_layer,d_unit,LINK_TYPE) \
  AddLink_(s_net,s_layer,s_unit,d_net,d_layer,d_unit,TAG(LINK_TYPE),UNI_DIRECTIONAL,0)

#define ConnectGn(s_net,s_layer,s_unit,d_net,d_layer,d_unit,LINK_TYPE,group_n) \
  AddLink_(s_net,s_layer,s_unit,d_net,d_layer,d_unit,TAG(LINK_TYPE),UNI_DIRECTIONAL,group_n)

#define ConnectBidir(s_net,s_layer,s_unit,d_net,d_layer,d_unit,LINK_TYPE) \
  AddLink_(s_net,s_layer,s_unit,d_net,d_layer,d_unit,TAG(LINK_TYPE),BI_DIRECTIONAL,0)

#define ConnectBidirGn(s_net,s_layer,s_unit,d_net,d_layer,d_unit,LINK_TYPE,group_n) \
  AddLink_(s_net,s_layer,s_unit,d_net,d_layer,d_unit,TAG(LINK_TYPE),BI_DIRECTIONAL,group_n)
