/*
 * $Id: config.h,v 1.1 90/12/07 12:00:37 drew Exp $
 * 
 * $Log:	config.h,v $
 * Revision 1.1  90/12/07  12:00:37  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

/***
 * Configuration file - try to put all machine dependent stuff in here
 */

/*
 * Some machines don't have isnan() quiet_nan() or infinity()
 * If NO_BUILT_IN_QUIET_NAN is defined, a function for quiet_nan() will
 * be defined in sim-math.c.
 * Likewise for NO_BUILT_IN_INFINITY.
 * Probably have to do something for the stellar here!
 *
 * Uncomment the appropriate among the following
 #define NO_BUILT_IN_INFINITY
    (if your system doesn't supply infinity() )

 #define NO_BUILT_IN_QUIET_NAN
    (if your system doesn't supply quiet_nan() )

 #define NO_GEN_NAN
    (if your system won't generate nan by asin(2.0))

 #define NO_GEN_INFINITY
    (if your system won't generate inf by 1/0.0)
 *
 * If you define NO_GEN_INFINITY then you will not have the infinity()
 * function at all.  Nothing yet uses it anyway.
 * If you define NO_GEN_NAN then sim-math will attempt to generate
 * the NaN value by using a bit-pattern  (in calc_quiet_nan()), it
 * is currently essential to have this value.
 */

/***
 * This is a multi-system version of the config.h file, it includes the
 * appropriate one:
 */
#if defined(sgi)
#include "config.sgi.h"
#endif

#if defined(mips) && !defined(sgi)
#include "config.mips.h"
#endif

#if defined(sun)
#include "config.sun.h"
#endif

#if defined(stellar)
#include "config.stellar.h"
#endif
