/*
 * $Id: save.d.c,v 1.2 90/12/14 15:01:54 drew Exp $
 * 
 * $Log:	save.d.c,v $
 * Revision 1.2  90/12/14  15:01:54  drew
 * Documented and cleaned up.
 * 
 * Revision 1.1  90/12/07  12:01:00  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

/**********************************************************************
 *	File name:   save.d.c
 *	Description: contains the dummy functions ReadWeights and
 *			SaveWeights whic should be overwritten for
 *			each application.
 *
 *	Exported functions:
 *		int		SaveWeights(tnet)
 *		int		ReadWeights(tnet)
 *
 *	Exported variables:
 *		none
 *
 **********************************************************************/

#include <itf/itf.h>
#include "sim-dummy.h"
#include <sim.h>


/**********************************************************************
 *	Name:         ReadWeights
 *	Description:  Dummy routine for reading in weights from a save
 *			file
 *	Parameters:   NETWORK*	tnet - the network to read in to.
 *	Return Value: int	ReadWeights - +1
 **********************************************************************/
int		ReadWeights(tnet)
NETWORK*	tnet;
{
  fprintf
    (stderr,"%s\n%s\n%s\n%s\n",
     "The function `ReadWeights' is not implemented",
     "For this command to work properly you must link a function",
     "called `ReadWeights' in your program.  The default version of",
     "this function is in the simulator library file `save-weight.c'.");
  return 1;
}
/**********************************************************************/

/**********************************************************************
 *	Name:         SaveWeights
 *	Description:  Dummy routine for saving weights to a save file
 *	Parameters:   NETWORK*	tnet - the network to save.
 *	Return Value: int	SaveWeights - +1
 **********************************************************************/
int		SaveWeights(tnet)
NETWORK*	tnet;
{
  fprintf
    (stderr,"%s\n%s\n%s\n%s\n",
     "The function `SaveWeights' is not implemented",
     "For this command to work properly you must link a function",
     "called `SaveWeights' in your program.  The default version of",
     "this function is in the simulator library file `save-weight.c'.");
  return 1;
}
/**********************************************************************/
