/*
 * $Id: sim-math.h,v 1.2 90/12/13 14:30:56 xerion Exp $
 * 
 * $Log:	sim-math.h,v $
 * Revision 1.2  90/12/13  14:30:56  xerion
 * reorganized and documented the file.
 * 
 * Revision 1.1  90/12/07  12:01:16  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#ifndef _SIM_MATH_
#define _SIM_MATH_

/* random number generators */
extern real		RandReal(); /* real, real */
extern real		RandUniform();
extern unsigned int	RandInt();/* unsigned int */

/* square of a number */
extern real	sqr();	/* real */

/* for calculating quiet_nan or infinity */
extern float	calc_quiet_nan();
extern float	calc_infinity();

#ifdef NO_BUILT_IN_QUIET_NAN
extern float	quiet_nan();
#endif NO_BUILT_IN_QUIET_NAN

#ifndef NO_GEN_INFINITY
#ifdef NO_BUILT_IN_INFINITY
extern float	infinity();
#endif NO_BUILT_IN_INFINITY
#endif NO_GEN_INFINITY

#ifdef DOUBLE
#  define MAXREAL MAXDOUBLE
#else
#  define MAXREAL MAXFLOAT
#endif DOUBLE

#endif _SIM_MATH_
