/*
 * $Id: sim.h,v 1.1 90/12/07 12:01:18 drew Exp $
 * 
 * $Log:	sim.h,v $
 * Revision 1.1  90/12/07  12:01:18  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

/**
 * sim.h
 *
 * externs etc for the simulator
 */
#ifndef _SIM_
#define _SIM_

#define TAG(X) CONCAT(TAG_,X)
#define CONCAT(A,B) THIS(A)B
#define THIS(X) X

#ifndef DUMMY_UL
#include <ul.h>
#include <.ul-tags.h>
#endif

#include <stdio.h>
/* #include <itf/assert.h> */
#include <sim/config.h>
#include <sim/network.h>
#include <sim/traverse.h>
#include <sim/build.h>
#include <sim/sigmoid.h>
#include <sim/sim-math.h>
#include <sim/find-link.h>

extern char *my_name;
#define SIMBUFSIZE 100 /* for temporary strings */
extern char sim_buf[SIMBUFSIZE];

/* say we can allocate up to 32Mb in a single malloc */
#define MAX_MALLOC	(1<<25)

#define SAVE_FEATURE 1

#ifndef UNIT_OUTPUT
#define UNIT_OUTPUT(unit) (unit)->output
#endif

#ifndef UNIT_TARGET
#define UNIT_TARGET(unit) (unit)->target
#endif

#ifndef UNIT_INPUT
#define UNIT_INPUT(unit) (unit)->input
#endif

#ifndef LINK_WEIGHT
#define LINK_WEIGHT(link) (link)->weight
#endif

#ifndef WEIGHT_NAME
#define WEIGHT_NAME ".weight"
#endif

#ifndef OBJECTIVE_FUNCTION
#define OBJECTIVE_FUNCTION(net) (net->p->sumsq_errors)
#endif

#ifndef OBJECTIVE_FUNCTION_NAME
#define OBJECTIVE_FUNCTION_NAME "Error"
#endif

#endif
