/*
 * $Id: tgoto.c,v 1.1 90/12/07 12:30:28 drew Exp $
 * 
 * $Log:	tgoto.c,v $
# Revision 1.1  90/12/07  12:30:28  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include <stdio.h>
#include <string.h>
static char area1[100];		/* used to store mode strings */
static char bp[1024];


main(argc,argv)
int argc;
char *argv[];
{
  char *area=area1;
  char *env;
  char *cm,*bold_on,*attr_off;
  extern char *tgetstr();
  extern char *getenv();
  tgetent(bp,getenv("TERM"));
  cm = tgetstr("cm",&area);
  bold_on = tgetstr("md",&area);
  attr_off = tgetstr("me",&area);
  if (bold_on==NULL || attr_off==NULL) {
    fprintf(stderr,"%s: terminal doesn't have capability to do bold\n",argv[0]);
    exit(1);
  }
  if (cm==NULL) {
    fprintf(stderr,"%s: terminal can't do cursor movement\n",argv[0]);
    exit(1);
  }
  if (strchr(bold_on,'$')) *strchr(bold_on,'$') = 0; /* kill the delay part */
  if (strchr(attr_off,'$')) *strchr(attr_off,'$') = 0; /* kill the delay part*/
  if (argc!=4) {
    fprintf(stderr,"usage: %s <column> <line> <string>\n",argv[0]);
  }
  printf("Moving to %d %d\n",atoi(argv[1]),atoi(argv[2]));
  printf("%s%s",tgoto(cm,atoi(argv[1]),atoi(argv[2])),argv[3]);
}
